#import "TapjoyPlugin.h"
#import "Tapjoy.h"
#import "TJPlacement.h"


@implementation TapjoyPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"tapjoy"
            binaryMessenger:[registrar messenger]];
  TapjoyPlugin* instance = [[TapjoyPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  } 
   else if ([@"setDebugEnabled" isEqualToString:call.method]) {
       bool setDebugEnabled = [weakSelf setDebugEnabled];
   [Tapjoy setDebugEnabled:setDebugEnabled];
  } else if ([@"connect" isEqualToString:call.method]) {
      NSString *tapjoyKey = call.arguments("tapjoyKey");
    [Tapjoy connect:tapjoyKey];

    -(void)tjcConnectSuccess:(NSNotification*)notifyObj {

    NSLog(@"Tapjoy connect Succeeded");
}
-(void)tjcConnectFail:(NSNotification*)notifyObj {
    NSLog(@"Tapjoy connect Failed");
}
  } else if ([@"getPlacement" isEqualToString:call.method]) {
      NSString *placementName = call.arguments("placementName");
   TJPlacement *p = [TJPlacement placementWithName:placementName delegate:self ];
   [p requestContent];
   if(p.isContentReady) {
     NSLog(@"Tapjoy content is ready");
   [p showContentWithViewController: nil];
}
else {
  NSLog(@"Tapjoy content is not ready");
}

  }  else if ([@"getLimitedPlacement" isEqualToString:call.method]) {
    - (void)requestDidSucceed:(TJPlacement*)placement{

    }

- (void)requestDidFail:(TJPlacement*)placement error:(NSError*)error{

}
- (void)contentIsReady:(TJPlacement*)placement{

}
- (void)contentDidAppear:(TJPlacement*)placement{

} 
- (void)contentDidDisappear:(TJPlacement*)placement{

}
- (void)placement:(TJPlacement*)placement didRequestPurchase:(TJActionRequest*)request productId:(NSString*)productId {
}
- (void)placement:(TJPlacement*)placement didRequestReward:(TJActionRequest*)request itemId:(NSString*)itemId quantity:(int)quantity {

}
  } else if ([@"setUserConsent" isEqualToString:call.method]) {
      NSString *consent = call.arguments("consent");
[Tapjoy setUserConsent:consent];
  } else if ([@"subjectToGDPR" isEqualToString:call.method]) {
      bool gdprApplicable = call.arguments("gdprApplicable");
    [Tapjoy subjectToGDPR:gdprApplicable];
  } 
  else {
    result(FlutterMethodNotImplemented);
  }

}
@end

